Mail::Box::Parser::Perl(3)

NAME
Mail::Box::Parser::Perl - reading messages from file using Perl

INHERITANCE
 Mail::Box::Parser::Perl
   is a Mail::Box::Parser
   is a Mail::Reporter

SYNOPSIS

DESCRIPTION
The "Mail::Box::Parser::Perl" implements parsing of messages in Perl. This may be a little slower than the "C" based parser Mail::Box::Parser::C, but will also work on platforms where no C compiler is available.

Extends "DESCRIPTION" in Mail::Box::Parser.

METHODS
Extends "METHODS" in Mail::Box::Parser.

  Constructors
Extends "Constructors" in Mail::Box::Parser.

$class->new(%options)
    Inherited, see "METHODS" in Mail::Box::Parser

     -Option           --Defined in       --Default
      file                                  undef
      filename                              <required>
      fix_header_errors  Mail::Box::Parser  false
      mode                                  'r'
      trusted            Mail::Box::Parser  false

    file => $filehandle
        Any IO::File or "GLOB" $filehandle which can be used to read the data from. In case this option is specified, the "filename" is informational only.

    filename => FILENAME
        The name of the file to be read.

    fix_header_errors => BOOLEAN
    mode => $mode
        File open $mode, which defaults to 'r', which means `read-only'. See "perldoc -f open" for possible modes. Only applicable when no "file" is specified.

    trusted => BOOLEAN

  Attributes
Extends "Attributes" in Mail::Box::Parser.

$any->defaultParserType( [$class] )
    Inherited, see "Attributes" in Mail::Box::Parser

$obj->file()

$obj->filename()
    Returns the name of the file this parser is working on.

$obj->fixHeaderErrors( [BOOLEAN] )
    Inherited, see "Attributes" in Mail::Box::Parser

$obj->openMode()

$obj->trusted()
    Inherited, see "Attributes" in Mail::Box::Parser

  Parsing
Extends "Parsing" in Mail::Box::Parser.

$obj->bodyAsFile( $fh [$chars, [$lines]] )
    Inherited, see "Parsing" in Mail::Box::Parser

$obj->bodyAsList( [$chars, [$lines]] )
    Inherited, see "Parsing" in Mail::Box::Parser

$obj->bodyAsString( [$chars, [$lines]] )
    Inherited, see "Parsing" in Mail::Box::Parser

$obj->bodyDelayed( [$chars, [$lines]] )
    Inherited, see "Parsing" in Mail::Box::Parser

$obj->closeFile()
    Close the file which was being parsed.

$obj->fileChanged()
    Returns whether the file which is parsed has changed after the last time takeFileInfo() was called.

$obj->filePosition( [$position] )
    Returns the location of the next byte to be used in the file which is parsed. When a $position is specified, the location in the file is moved to the indicated spot first.

$obj->lineSeparator()
    Inherited, see "Parsing" in Mail::Box::Parser

$obj->openFile(%options)
    [3.012] Open the file to be parsed.

$obj->readHeader()
    Inherited, see "Parsing" in Mail::Box::Parser

$obj->restart(%options)
    Restart the parser on a certain file, usually because the content has changed. The %options are passed to openFile().

$obj->start(%options)
    Start the parser by opening a file.

     -Option--Default
      file    undef

    file => FILEHANDLE|undef
        The file is already open, for instance because the data must be read from STDIN.

$obj->stop()
    Stop the parser, which will include a close of the file. The lock on the folder will not be removed (is not the responsibility of the parser). Improves base, see "Parsing" in Mail::Box::Parser

$obj->takeFileInfo()
    Capture some data about the file being parsed, to be compared later.

  Error handling
Extends "Error handling" in Mail::Box::Parser.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Box::Parser.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Reporter

DIAGNOSTICS

Error: class $package does not implement method $method.
    Fatal error: the specific $package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package. Cast by notImplemented()

Error: filename or handle required to create a parser.
    Cast by new()

Error: parser $type does not extend $pkg.
    Cast by defaultParserType()

Warning: unexpected end of header in $file:\n $line
    Cast by readHeader()

SEE ALSO
This module is part of Mail-Message version 4.01, built on December 13, 2025. Website: http://perl.overmeer.net/CPAN/

LICENSE
For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.